//
// $Id: moc.h,v 1.28 2001/05/14 21:55:57 kmacleod Exp $
//

#ifndef _moc_h
#define _moc_h

#include <stdlib.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct id_ * (*moc_method)(struct id_ * self, int selector, ...);
typedef struct id_ * (*isa_list[])(struct id_ * self, int selector, ...);
typedef struct id_ { isa_list *isa_; } *id;

#include "moc_cexcept.h"
define_exception_type(id);
extern struct exception_context the_exception_context[1];

id doesNotUnderstand(id self, int selector, ...);
int ok(int truth_value, int test_number);
int has_prefix(const char *name, char **localname_p);
char *escape_string(char *string);
void hash_alloc(id **values, int **hashes, int *used, int *allocated,
		int alloc_size);
int hash_lookup(id *values, int *hashes, int allocated, int hash,
		int (*match_func)(id, const void *), const void *user_data);
void hash_realloc(id **values, int **hashes, int *allocated);
extern char *methods[];

id Int__new_i(const int ii);
int Int_i(id self);
id String__new_s(const char *str);
id String__new_sn(const char *str, size_t len_str);
id String__new_g(const char *str);
id String__new_gn(const char *str, size_t len_str);
int String_hash_sn(const char *str, size_t len_str);
const char *String_s(id self);
const char *String_gpn(id self, int *len_self);
id Symbol__new_S(id str);
id Symbol__new_s(const char *str);
id Symbol__new_sn(const char *str, size_t len_str);
id Symbol__new_g(const char *str);
id Symbol__new_gn(const char *str, size_t len_str);
id Key__new_ss(const char *namespace_uri, const char *local_name);
id Key__new_yy(id namespace_uri, id local_name);
id List_ati_i(id self, int ii);

id IF_new(char *klass);
id IF_get(id node, id key_alias, char *namespace_uri, char *key);
id IF_put(id node, id key_alias, char *namespace_uri, char *key, id value);
id IF_type(id obj);
id IF_call(id obj, char *method);
id IF_call1(id obj, char *method, id arg1);
id IF_call2(id obj, char *method, id arg1, id arg2);
id IF_array_get(id array, int ii);
int IF_array_length(id array);
id IF_firstkey(id node);
id IF_nextkey(id node);
id IF_index(char *namespace_uri, char *localname);
void **IF_keep(id obj);
void IF_release(id obj);
const char *IF_strerrorln(id err);

// to be converted to MOC
#define MOC_NIL (Nil__new(NULL, 0))
#define MOC_TRUE (Symbol__new_s("true"))
#define MOC_FALSE (Symbol__new_s("false"))

#define NilType (Symbol__new_s("NilType"))
#define NodeType (Symbol__new_s("NodeType"))
#define ListType (Symbol__new_s("ListType"))
#define IntType (Symbol__new_s("IntType"))
#define StringType (Symbol__new_s("StringType"))
#define HashType (Symbol__new_s("HashType"))
#define SymbolType (Symbol__new_s("SymbolType"))
#define KeyType (Symbol__new_s("KeyType"))
#define FileStreamType (Symbol__new_s("FileStreamType"))
#define StringStreamType (Symbol__new_s("StringStreamType"))
#define PerlObjectType (Symbol__new_s("PerlObjectType"))
#define XPath_StepType (Symbol__new_s("XPath_StepType"))
#define KeyAliasType (Symbol__new_s("KeyAliasType"))
#define MyNodeType (Symbol__new_s("MyNodeType"))
#define MyHandlerType (Symbol__new_s("MyHandlerType"))
#define NullHandlerType (Symbol__new_s("NullHandlerType"))
#define XML_DocumentType (Symbol__new_s("document"))
#define XML_ElementType (Symbol__new_s("element"))
#define XML_AttributeType (Symbol__new_s("attribute"))
#define XML_CharactersType (Symbol__new_s("characters"))
#define XML_CommentType (Symbol__new_s("comment"))
#define XML_ProcessingInstructionType (Symbol__new_s("processing_instruction"))
#define SAXDriver_ExpatType (Symbol__new_s("SAXDriver_ExpatType"))
#define TreeBuilderType (Symbol__new_s("TreeBuilderType"))

#ifdef __cplusplus
} // extern "C"
#endif

#endif // moc_h
